import { Plugin } from '@nocobase/server';
import { Registry } from '@nocobase/utils';
import { Logger } from '@nocobase/logger';
import Processor from './Processor';
import { CustomFunction } from './functions';
import type Trigger from './triggers';
import type Instruction from './instructions';
import type { ExecutionModel, WorkflowModel } from './types';
type ID = number | string;
export default class WorkflowPlugin extends Plugin {
    instructions: Registry<Instruction>;
    triggers: Registry<Trigger>;
    functions: Registry<CustomFunction>;
    private ready;
    private executing;
    private pending;
    private events;
    private loggerCache;
    getLogger(workflowId: ID): Logger;
    onBeforeSave: (instance: WorkflowModel, options: any) => Promise<void>;
    initTriggers<T extends Trigger>(more?: {
        [key: string]: T | {
            new (p: Plugin): T;
        };
    }): void;
    initInstructions<T extends Instruction>(more?: {
        [key: string]: T | {
            new (p: Plugin): T;
        };
    }): void;
    load(): Promise<void>;
    toggle(workflow: WorkflowModel, enable?: boolean): void;
    trigger(workflow: WorkflowModel, context: object, options?: {
        context?: any;
    }): void;
    resume(job: any): Promise<void>;
    createProcessor(execution: ExecutionModel, options?: {}): Processor;
    private prepare;
    private dispatch;
    private process;
}
export {};
