import { Registry } from '@nocobase/utils';
import { Instruction } from '.';
import type Processor from '../Processor';
import type { FlowNodeModel, JobModel } from '../types';
type Comparer = (a: any, b: any) => boolean;
export declare const calculators: Registry<Comparer>;
export declare class ConditionInstruction extends Instruction {
    run(node: FlowNodeModel, prevJob: any, processor: Processor): Promise<{
        status: number;
        result: boolean;
        nodeId: number;
        upstreamId: any;
    } | {
        result: any;
        status: number;
    }>;
    resume(node: FlowNodeModel, branchJob: JobModel, processor: Processor): Promise<any>;
}
export default ConditionInstruction;
